diff -rupN arpack++1.2.orig/include/arrsnsym.h arpack++1.2.patched/include/arrsnsym.h
--- arpack++1.2.orig/include/arrsnsym.h	2000-03-03 21:30:50.000000000 +0100
+++ arpack++1.2.patched/include/arrsnsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARRSNSYM_H
 #define ARRSNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arerror.h"
 #include "debug.h"
@@ -35,7 +36,7 @@ class ARrcNonSymStdEig: public virtual A
 
  // a.1) Memory control functions.
 
-  int ValSize() { return nev+1; }
+  int ValSize() { return this->nev+1; }
   // Provides the size of array EigVal.
 
   void ValAllocate();
@@ -226,10 +227,10 @@ template<class ARFLOAT>
 inline void ARrcNonSymStdEig<ARFLOAT>::ValAllocate()
 {
 
-  if (EigValR == NULL) {
-    EigValR = new ARFLOAT[ValSize()];
-    EigValI = new ARFLOAT[ValSize()];
-    newVal = true;
+  if (this->EigValR == NULL) {
+    this->EigValR = new ARFLOAT[ValSize()];
+    this->EigValI = new ARFLOAT[ValSize()];
+    this->newVal = true;
   }
 
 } // ValAllocate.
@@ -239,11 +240,11 @@ template<class ARFLOAT>
 inline void ARrcNonSymStdEig<ARFLOAT>::WorkspaceAllocate()
 {
 
-  lworkl  = 3*ncv*(ncv+2);
-  lworkv  = 3*ncv;
-  lrwork  = 0;
-  workl   = new ARFLOAT[lworkl+1];
-  workv   = new ARFLOAT[lworkv+1];
+  this->lworkl  = 3*this->ncv*(this->ncv+2);
+  this->lworkv  = 3*this->ncv;
+  this->lrwork  = 0;
+  this->workl   = new ARFLOAT[this->lworkl+1];
+  this->workv   = new ARFLOAT[this->lworkv+1];
 
 } // WorkspaceAllocate.
 
@@ -252,8 +253,8 @@ template<class ARFLOAT>
 inline void ARrcNonSymStdEig<ARFLOAT>::Aupp()
 {
 
-  naupp(ido, bmat, n, which, nev, tol, resid, ncv, V, n,
-        iparam, ipntr, workd, workl, lworkl, info);
+  naupp(this->ido,this-> bmat, this->n, this->which, this->nev, this->tol, this->resid, this->ncv, this->V, this->n,
+        this->iparam, this->ipntr, this->workd, this->workl, this->lworkl, this->info);
 
 } // Aupp.
 
@@ -262,9 +263,9 @@ template<class ARFLOAT>
 inline void ARrcNonSymStdEig<ARFLOAT>::Eupp()
 {
 
-  neupp(rvec, HowMny, EigValR, EigValI, EigVec, n, sigmaR,
-        sigmaI, workv, bmat, n, which, nev, tol, resid, ncv, V,
-        n, iparam, ipntr, workd, workl, lworkl, info);
+  neupp(this->rvec, this->HowMny, this->EigValR, this->EigValI, this->EigVec, this->n, this->sigmaR,
+        this->sigmaI, this->workv, this->bmat, this->n, this->which, this->nev, this->tol, this->resid, this->ncv, this->V,
+        this->n, this->iparam, this->ipntr, this->workd, this->workl, this->lworkl, this->info);
 
 } // Eupp.
 
@@ -273,7 +274,7 @@ template<class ARFLOAT>
 inline int ARrcNonSymStdEig<ARFLOAT>::CheckNev(int nevp)
 {
 
-  if ((nevp<=1)||(nevp>=(n-1))) { // nev must satisfy 1 < nev < n-1.
+  if ((nevp<=1)||(nevp>=(this->n-1))) { // nev must satisfy 1 < nev < n-1.
     throw ArpackError(ArpackError::NEV_OUT_OF_BOUNDS);
   }
   return nevp;
@@ -285,9 +286,9 @@ template<class ARFLOAT>
 bool ARrcNonSymStdEig<ARFLOAT>::ConjEigVec(int i)
 {
 
-  if (EigValI[i] == (ARFLOAT)0.0) return false;
+  if (this->EigValI[i] == (ARFLOAT)0.0) return false;
   int j = i-1;
-  while ((j >= 0) && (EigValI[j] != (ARFLOAT)0.0)) j--;
+  while ((j >= 0) && (this->EigValI[j] != (ARFLOAT)0.0)) j--;
   if (((i-j)%2) == 0) {
     return true;
   }
@@ -395,10 +396,10 @@ template<class ARFLOAT>
 ARFLOAT* ARrcNonSymStdEig<ARFLOAT>::GetVectorImag()
 {
 
-  if (ido != 3) {
+  if (this->ido != 3) {
     throw ArpackError(ArpackError::CANNOT_GET_VECTOR, "GetVectorImag");
   }
-  return &workl[ipntr[6]];
+  return &this->workl[this->ipntr[6]];
 
 } // GetVectorImag.
 
@@ -408,14 +409,14 @@ int ARrcNonSymStdEig<ARFLOAT>::
 Eigenvalues(ARFLOAT* &EigValRp, ARFLOAT* &EigValIp, bool ivec, bool ischur)
 {
 
-  if (ValuesOK) {                                 // Eigenvalues are available.
+  if (this->ValuesOK) {                                 // Eigenvalues are available.
     if ((EigValRp == NULL)&&(EigValIp == NULL)) { // Moving eigenvalues.
-      EigValRp = EigValR;
-      EigValIp = EigValI;
-      EigValR  = NULL;
-      EigValI  = NULL;
-      newVal   = false;
-      ValuesOK = false;
+      EigValRp = this->EigValR;
+      EigValIp = this->EigValI;
+      this->EigValR  = NULL;
+      this->EigValI  = NULL;
+      this->newVal   = false;
+      this->ValuesOK = false;
     }
     else {                                        // Copying eigenvalues.
       try {
@@ -423,33 +424,33 @@ Eigenvalues(ARFLOAT* &EigValRp, ARFLOAT*
         if (EigValIp == NULL) EigValIp = new ARFLOAT[ValSize()];
       }
       catch (ArpackError) { return 0; }
-      copy(nconv,EigValR,1,EigValRp,1);
-      copy(nconv,EigValI,1,EigValIp,1);
+      copy(this->nconv,this->EigValR,1,EigValRp,1);
+      copy(this->nconv,this->EigValI,1,EigValIp,1);
     }
   }
   else {
-    if (newVal) {
-      delete[] EigValR;
-      delete[] EigValI;
-      newVal = false;
+    if (this->newVal) {
+      delete[] this->EigValR;
+      delete[] this->EigValI;
+      this->newVal = false;
     }
     try {
       if (EigValRp == NULL) EigValRp = new ARFLOAT[ValSize()];
       if (EigValIp == NULL) EigValIp = new ARFLOAT[ValSize()];
     }
     catch (ArpackError) { return 0; }
-    EigValR = EigValRp;
-    EigValI = EigValIp;
+    this->EigValR = EigValRp;
+    this->EigValI = EigValIp;
     if (ivec) {                              // Finding eigenvalues and vectors.
-      nconv = FindEigenvectors(ischur);
+      this->nconv = this->FindEigenvectors(ischur);
     }
     else {                                   // Finding eigenvalues only.
-      nconv = FindEigenvalues();
+      this->nconv = this->FindEigenvalues();
     }
-    EigValR = NULL;
-    EigValI = NULL;
+    this->EigValR = NULL;
+    this->EigValI = NULL;
   }
-  return nconv;
+  return this->nconv;
 
 } // Eigenvalues(EigValRp, EigValIp, ivec, ischur).
 
@@ -460,35 +461,35 @@ EigenValVectors(ARFLOAT* &EigVecp, ARFLO
                 ARFLOAT* &EigValIp, bool ischur)
 {
 
-  if (ValuesOK) {               // Eigenvalues are already available .
-    nconv = Eigenvalues(EigValRp, EigValIp, false);
-    nconv = Eigenvectors(EigVecp, ischur);
+  if (this->ValuesOK) {               // Eigenvalues are already available .
+    this->nconv = Eigenvalues(EigValRp, EigValIp, false);
+    this->nconv = Eigenvectors(EigVecp, ischur);
   }
   else {                        // Eigenvalues ans vectors are not available.
-    if (newVec) {
-      delete[] EigVec;
-      newVec = false;
-    }
-    if (newVal) {
-      delete[] EigValR;
-      delete[] EigValI;
-      newVal = false;
+    if (this->newVec) {
+      delete[] this->EigVec;
+      this->newVec = false;
+    }
+    if (this->newVal) {
+      delete[] this->EigValR;
+      delete[] this->EigValI;
+      this->newVal = false;
     }
     try {
-      if (EigVecp  == NULL) EigVecp  = new ARFLOAT[ValSize()*n];
+      if (EigVecp  == NULL) EigVecp  = new ARFLOAT[ValSize()*this->n];
       if (EigValRp == NULL) EigValRp = new ARFLOAT[ValSize()];
       if (EigValIp == NULL) EigValIp = new ARFLOAT[ValSize()];
     }
     catch (ArpackError) { return 0; }
-    EigVec  = EigVecp;
-    EigValR = EigValRp;
-    EigValI = EigValIp;
-    nconv   = FindEigenvectors(ischur);
-    EigVec  = NULL;
-    EigValR = NULL;
-    EigValI = NULL;
+    this->EigVec  = EigVecp;
+    this->EigValR = EigValRp;
+    this->EigValI = EigValIp;
+    this->nconv   = this->FindEigenvectors(ischur);
+    this->EigVec  = NULL;
+    this->EigValR = NULL;
+    this->EigValI = NULL;
   }
-  return nconv;
+  return this->nconv;
 
 } // EigenValVectors(EigVecp, EigValRp, EigValIp, ischur).
 
@@ -500,13 +501,13 @@ inline arcomplex<ARFLOAT> ARrcNonSymStdE
 
   // Returning i-eth eigenvalue.
 
-  if (!ValuesOK) {
+  if (!this->ValuesOK) {
     throw ArpackError(ArpackError::VALUES_NOT_OK, "Eigenvalue(i)");
   }
-  else if ((i>=nconv)||(i<0)) {
+  else if ((i>=this->nconv)||(i<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "Eigenvalue(i)");
   }
-  return arcomplex<ARFLOAT>(EigValR[i],EigValI[i]);
+  return arcomplex<ARFLOAT>(this->EigValR[i],this->EigValI[i]);
 
 } // Eigenvalue(i).
 #endif // ARCOMP_H
@@ -518,13 +519,13 @@ inline ARFLOAT ARrcNonSymStdEig<ARFLOAT>
 
   // Returning the real part of i-eth eigenvalue.
 
-  if (!ValuesOK) {
+  if (!this->ValuesOK) {
     throw ArpackError(ArpackError::VALUES_NOT_OK, "EigenvalueReal(i)");
   }
-  else if ((i>=nconv)||(i<0)) {
+  else if ((i>=this->nconv)||(i<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "EigenvalueReal(i)");
   }
-  return EigValR[i];
+  return this->EigValR[i];
 
 } // EigenvalueReal(i).
 
@@ -535,13 +536,13 @@ inline ARFLOAT ARrcNonSymStdEig<ARFLOAT>
 
   // Returning the imaginary part of i-eth eigenvalue.
 
-  if (!ValuesOK) {
+  if (!this->ValuesOK) {
     throw ArpackError(ArpackError::VALUES_NOT_OK, "EigenvalueImag(i)");
   }
-  else if ((i>=nconv)||(i<0)) {
+  else if ((i>=this->nconv)||(i<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "EigenvalueImag(i)");
   }
-  return EigValI[i];
+  return this->EigValI[i];
 
 } // EigenvalueImag(i).
 
@@ -554,21 +555,21 @@ Eigenvector(int i, int j)
 
   // Returning element j of i-eth eigenvector.
 
-  if ((!VectorsOK)||(!ValuesOK)) {
+  if ((!this->VectorsOK)||(!this->ValuesOK)) {
     throw ArpackError(ArpackError::VECTORS_NOT_OK, "Eigenvector(i,j)");
   }
-  else if ((i>=nconv)||(i<0)||(j>=n)||(j<0)) {
+  else if ((i>=this->nconv)||(i<0)||(j>=this->n)||(j<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "Eigenvector(i,j)");
   }
-  if (EigValI[i]==(ARFLOAT)0.0) {   // Real eigenvalue.
-    return arcomplex<ARFLOAT>(EigVec[i*n+j],(ARFLOAT)0.0);
+  if (this->EigValI[i]==(ARFLOAT)0.0) {   // Real eigenvalue.
+    return arcomplex<ARFLOAT>(this->EigVec[i*this->n+j],(ARFLOAT)0.0);
   }
   else {                            // Complex eigenvalue.
-    if (EigValI[i]>(ARFLOAT)0.0) {  // with positive imaginary part.
-      return arcomplex<ARFLOAT>(EigVec[i*n+j], EigVec[(i+1)*n+j]);
+    if (this->EigValI[i]>(ARFLOAT)0.0) {  // with positive imaginary part.
+      return arcomplex<ARFLOAT>(this->EigVec[i*this->n+j], this->EigVec[(i+1)*this->n+j]);
     }
     else {                          // with negative imaginary part.
-      return arcomplex<ARFLOAT>(EigVec[(i-1)*n+j], -EigVec[i*n+j]);
+      return arcomplex<ARFLOAT>(this->EigVec[(i-1)*this->n+j], -this->EigVec[i*this->n+j]);
     }
   }
 
@@ -582,13 +583,13 @@ inline ARFLOAT ARrcNonSymStdEig<ARFLOAT>
 
   // Returning the real part of element j of i-eth eigenvector.
 
-  if (!VectorsOK) {
+  if (!this->VectorsOK) {
     throw ArpackError(ArpackError::VECTORS_NOT_OK, "EigenvectorReal(i,j)");
   }
-  else if ((i>=nconv)||(i<0)||(j>=n)||(j<0)) {
+  else if ((i>=this->nconv)||(i<0)||(j>=this->n)||(j<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "EigenvectorReal(i,j)");
   }
-  return EigVec[i*n+j];
+  return this->EigVec[i*this->n+j];
 
 } // EigenvectorReal(i,j).
 
@@ -599,21 +600,21 @@ inline ARFLOAT ARrcNonSymStdEig<ARFLOAT>
 
   // Returning the imaginary part of element j of i-eth eigenvector.
 
-  if ((!VectorsOK)||(!ValuesOK)) {
+  if ((!this->VectorsOK)||(!this->ValuesOK)) {
     throw ArpackError(ArpackError::VECTORS_NOT_OK, "EigenvectorImag(i,j)");
   }
-  else if ((i>=nconv)||(i<0)||(j>=n)||(j<0)) {
+  else if ((i>=this->nconv)||(i<0)||(j>=this->n)||(j<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "EigenvectorImag(i,j)");
   }
-  if (EigValI[i]==(ARFLOAT)0.0) {   // Real eigenvalue.
+  if (this->EigValI[i]==(ARFLOAT)0.0) {   // Real eigenvalue.
     return (ARFLOAT)0.0;
   }
   else {                            // Complex eigenvalue.
-    if (EigValI[i]>(ARFLOAT)0.0) {  // with positive imaginary part.
-      return EigVec[(i+1)*n+j];
+    if (this->EigValI[i]>(ARFLOAT)0.0) {  // with positive imaginary part.
+      return this->EigVec[(i+1)*this->n+j];
     }
     else {                          // with negative imaginary part.
-      return -EigVec[i*n+j];
+      return -this->EigVec[i*this->n+j];
     }
   }
 
@@ -624,10 +625,10 @@ template<class ARFLOAT>
 inline ARFLOAT* ARrcNonSymStdEig<ARFLOAT>::RawEigenvaluesImag()
 {
 
-  if (!ValuesOK) {
+  if (!this->ValuesOK) {
     throw ArpackError(ArpackError::VALUES_NOT_OK, "RawEigenvaluesImag");
   }
-  return EigValI;
+  return this->EigValI;
 
 } // RawEigenvaluesImag.
 
@@ -822,7 +823,7 @@ ARrcNonSymStdEig(int np, int nevp, char*
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
 } // Long constructor (regular mode).
@@ -847,7 +848,7 @@ operator=(const ARrcNonSymStdEig<ARFLOAT
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrssym.h arpack++1.2.patched/include/arrssym.h
--- arpack++1.2.orig/include/arrssym.h	2000-03-03 21:29:21.000000000 +0100
+++ arpack++1.2.patched/include/arrssym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,7 @@
 #ifndef ARRSSYM_H
 #define ARRSSYM_H
 
-#include <stddef.h>
+#include <cstddef>
 #include "arch.h"
 #include "arerror.h"
 #include "debug.h"
@@ -157,10 +157,10 @@ template<class ARFLOAT>
 inline void ARrcSymStdEig<ARFLOAT>::WorkspaceAllocate()
 {
 
-  lworkl  = ncv*(ncv+9);
-  lworkv  = 0;
-  lrwork  = 0;
-  workl   = new ARFLOAT[lworkl+1];
+  this->lworkl  = this->ncv*(this->ncv+9);
+  this->lworkv  = 0;
+  this->lrwork  = 0;
+  this->workl   = new ARFLOAT[this->lworkl+1];
 
 } // WorkspaceAllocate.
 
@@ -169,8 +169,8 @@ template<class ARFLOAT>
 inline void ARrcSymStdEig<ARFLOAT>::Aupp()
 {
 
-  saupp(ido, bmat, n, which, nev, tol, resid, ncv, V, n,
-        iparam, ipntr, workd, workl, lworkl, info);
+  saupp(this->ido, this->bmat, this->n, this->which, this->nev, this->tol, this->resid, this->ncv, this->V, this->n,
+        this->iparam, this->ipntr, this->workd, this->workl, this->lworkl, this->info);
 
 } // Aupp.
 
@@ -179,9 +179,9 @@ template<class ARFLOAT>
 inline void ARrcSymStdEig<ARFLOAT>::Eupp()
 {
 
-  seupp(rvec, HowMny, EigValR, EigVec, n, sigmaR, bmat,
-        n, which, nev, tol, resid, ncv, V, n, iparam,
-        ipntr, workd, workl, lworkl, info);
+  seupp(this->rvec, this->HowMny, this->EigValR, this->EigVec, this->n, this->sigmaR, this->bmat,
+        this->n, this->which, this->nev, this->tol, this->resid, this->ncv, this->V, this->n, this->iparam,
+        this->ipntr, this->workd, this->workl, this->lworkl, this->info);
 
 } // Eupp.
 
@@ -211,13 +211,13 @@ template<class ARFLOAT>
 ARFLOAT* ARrcSymStdEig<ARFLOAT>::PutVector()
 {
 
-  switch (ido) {
+  switch (this->ido) {
   case -1:
   case  1:                    // Returning OP*x.
   case  2:
-    return &workd[ipntr[2]];  // Returning B*x.
+    return &this->workd[this->ipntr[2]];  // Returning B*x.
   case  3:
-    return &workl[ipntr[11]]; // Returning shifts.
+    return &this->workl[this->ipntr[11]]; // Returning shifts.
   default:
     throw ArpackError(ArpackError::CANNOT_PUT_VECTOR, "PutVector");
   }
@@ -230,36 +230,36 @@ int ARrcSymStdEig<ARFLOAT>::
 Eigenvalues(ARFLOAT* &EigValp, bool ivec, bool ischur)
 {
 
-  if (ValuesOK) {                      // Eigenvalues are available.
+  if (this->ValuesOK) {                      // Eigenvalues are available.
     if (EigValp == NULL) {             // Moving eigenvalues.
-      EigValp  = EigValR;
-      EigValR  = NULL;
-      newVal   = false;
-      ValuesOK = false;
+      EigValp  = this->EigValR;
+      this->EigValR  = NULL;
+      this->newVal   = false;
+      this->ValuesOK = false;
     }
     else {                             // Copying eigenvalues.
-      copy(nconv,EigValR,1,EigValp,1);
+      copy(this->nconv,this->EigValR,1,EigValp,1);
     }
   }
   else {                               // Eigenvalues are not available.
-    if (newVal) {
-      delete[] EigValR;
-      newVal = false;
+    if (this->newVal) {
+      delete[] this->EigValR;
+      this->newVal = false;
     }
     if (EigValp == NULL) {
-      try { EigValp = new ARFLOAT[ValSize()]; }
+      try { EigValp = new ARFLOAT[this->ValSize()]; }
       catch (ArpackError) { return 0; }
     }
-    EigValR = EigValp;
+    this->EigValR = EigValp;
     if (ivec) {                        // Finding eigenvalues and eigenvectors.
-      nconv = FindEigenvectors(ischur);
+      this->nconv = this->FindEigenvectors(ischur);
     }
     else {                             // Finding eigenvalues only.
-      nconv = FindEigenvalues();
+      this->nconv = this->FindEigenvalues();
     }
-    EigValR = NULL;
+    this->EigValR = NULL;
   }
-  return nconv;
+  return this->nconv;
 
 } // Eigenvalues(EigValp, ivec, ischur).
 
@@ -269,31 +269,31 @@ int ARrcSymStdEig<ARFLOAT>::
 EigenValVectors(ARFLOAT* &EigVecp, ARFLOAT* &EigValp, bool ischur)
 {
 
-  if (ValuesOK) {                  // Eigenvalues are already available .
-    nconv = Eigenvalues(EigValp, false);
-    nconv = Eigenvectors(EigVecp, ischur);
+  if (this->ValuesOK) {                  // Eigenvalues are already available .
+    this->nconv = Eigenvalues(EigValp, false);
+    this->nconv = Eigenvectors(EigVecp, ischur);
   }
   else {                           // Eigenvalues and vectors are not available.
     try {
-      if (EigVecp == NULL) EigVecp = new ARFLOAT[ValSize()*n];
-      if (EigValp == NULL) EigValp = new ARFLOAT[ValSize()];
+      if (EigVecp == NULL) EigVecp = new ARFLOAT[this->ValSize()*this->n];
+      if (EigValp == NULL) EigValp = new ARFLOAT[this->ValSize()];
     }
     catch (ArpackError) { return 0; }
-    if (newVec) {
-      delete[] EigVec;
-      newVec = false;
+    if (this->newVec) {
+      delete[] this->EigVec;
+      this->newVec = false;
     }
-    if (newVal) {
-      delete[] EigValR;
-      newVal = false;
+    if (this->newVal) {
+      delete[] this->EigValR;
+      this->newVal = false;
     }
-    EigVec  = EigVecp;
-    EigValR = EigValp;
-    nconv   = FindEigenvectors(ischur);
-    EigVec  = NULL;
-    EigValR = NULL;
+    this->EigVec  = EigVecp;
+    this->EigValR = EigValp;
+    this->nconv   = this->FindEigenvectors(ischur);
+    this->EigVec  = NULL;
+    this->EigValR = NULL;
   }
-  return nconv;
+  return this->nconv;
 
 } // EigenValVectors(EigVecp, EigValp, ischur).
 
@@ -304,13 +304,13 @@ inline ARFLOAT ARrcSymStdEig<ARFLOAT>::E
 
   // Returning i-eth eigenvalue.
 
-  if (!ValuesOK) {
+  if (!this->ValuesOK) {
     throw ArpackError(ArpackError::VALUES_NOT_OK, "Eigenvalue(i)");
   }
-  else if ((i>=nconv)||(i<0)) {
+  else if ((i>=this->nconv)||(i<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "Eigenvalue(i)");
   }
-  return EigValR[i];
+  return this->EigValR[i];
 
 } // Eigenvalue(i).
 
@@ -321,13 +321,13 @@ inline ARFLOAT ARrcSymStdEig<ARFLOAT>::E
 
   // Returning element j of i-eth eigenvector.
 
-  if (!VectorsOK) {
+  if (!this->VectorsOK) {
     throw ArpackError(ArpackError::VECTORS_NOT_OK, "Eigenvector(i,j)");
   }
-  else if ((i>=nconv)||(i<0)||(j>=n)||(j<0)) {
+  else if ((i>=this->nconv)||(i<0)||(j>=this->n)||(j<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "Eigenvector(i,j)");
   }
-  return EigVec[i*n+j];
+  return this->EigVec[i*this->n+j];
 
 } // Eigenvector(i,j).
 
@@ -385,7 +385,7 @@ ARrcSymStdEig(int np, int nevp, char* wh
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
 } // Long constructor (regular mode).
@@ -411,7 +411,7 @@ operator=(const ARrcSymStdEig<ARFLOAT>& 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arscomp.h arpack++1.2.patched/include/arscomp.h
--- arpack++1.2.orig/include/arscomp.h	2000-02-21 14:36:40.000000000 +0100
+++ arpack++1.2.patched/include/arscomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARSCOMP_H
 #define ARSCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arseig.h"
 #include "arrscomp.h"
@@ -76,7 +77,7 @@ ARCompStdEig(int np, int nevp, ARFOP* ob
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, objOPp, MultOPxp, whichp,
                    ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -106,7 +107,7 @@ operator=(const ARCompStdEig<ARFLOAT, AR
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
@@ -115,4 +116,3 @@ operator=(const ARCompStdEig<ARFLOAT, AR
 
 
 #endif // ARSCOMP_H
-
diff -rupN arpack++1.2.orig/include/arseig.h arpack++1.2.patched/include/arseig.h
--- arpack++1.2.orig/include/arseig.h	2000-03-03 17:14:14.000000000 +0100
+++ arpack++1.2.patched/include/arseig.h	2006-01-26 15:37:50.000000000 +0100
@@ -19,7 +19,7 @@
 #ifndef ARSEIG_H
 #define ARSEIG_H
 
-#include <stddef.h>
+#include <cstddef>
 #include "arch.h"
 #include "arerror.h"
 #include "arrseig.h"
@@ -152,7 +152,7 @@ ChangeMultOPx(ARFOP* objOPp, void (ARFOP
 
   objOP   = objOPp;
   MultOPx = MultOPxp;
-  Restart();
+  this->Restart();
 
 } // ChangeMultOPx.
 
@@ -163,7 +163,7 @@ SetRegularMode(ARFOP* objOPp, void (ARFO
 {
 
   ChangeMultOPx(objOPp, MultOPxp);
-  NoShift();
+  this->NoShift();
 
 } // SetRegularMode.
 
@@ -184,37 +184,37 @@ template<class ARFLOAT, class ARTYPE, cl
 int ARStdEig<ARFLOAT, ARTYPE, ARFOP>::FindArnoldiBasis()
 {
 
-  if (!BasisOK) Restart();
+  if (!this->BasisOK) this->Restart();
 
   // Changing to auto shift mode.
 
-  if (!AutoShift) {
+  if (!this->AutoShift) {
     ArpackError::Set(ArpackError::CHANGING_AUTOSHIFT, "FindArnoldiBasis");
-    AutoShift=true;
+    this->AutoShift=true;
   }
 
   // ARPACK main loop.
 
-  while (!BasisOK) {
+  while (!this->BasisOK) {
 
     // Calling Aupp.
 
-    try { TakeStep(); }
+    try { this->TakeStep(); }
     catch (ArpackError) {
       ArpackError(ArpackError::CANNOT_FIND_BASIS, "FindArnoldiBasis");
       return 0;
     }
 
-    if ((ido == -1) || (ido == 1)) {
+    if ((this->ido == -1) || (this->ido == 1)) {
 
       // Performing Matrix vector multiplication: y <- OP*x.
 
-      (objOP->*MultOPx)(&workd[ipntr[1]],&workd[ipntr[2]]);
+      (objOP->*MultOPx)(&this->workd[this->ipntr[1]],&this->workd[this->ipntr[2]]);
 
     }
 
   }
-  return nconv;
+  return this->nconv;
 
 } // FindArnoldiBasis.
 
@@ -225,7 +225,7 @@ operator=(const ARStdEig<ARFLOAT, ARTYPE
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arsnsym.h arpack++1.2.patched/include/arsnsym.h
--- arpack++1.2.orig/include/arsnsym.h	2000-02-21 13:06:14.000000000 +0100
+++ arpack++1.2.patched/include/arsnsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARSNSYM_H
 #define ARSNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arseig.h"
 #include "arrsnsym.h"
@@ -76,7 +77,7 @@ ARNonSymStdEig(int np, int nevp, ARFOP* 
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, objOPp, MultOPxp, whichp,
                    ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -105,7 +106,7 @@ operator=(const ARNonSymStdEig<ARFLOAT, 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
@@ -114,4 +115,3 @@ operator=(const ARNonSymStdEig<ARFLOAT, 
 
 
 #endif // ARSNSYM_H
-
diff -rupN arpack++1.2.orig/include/arssym.h arpack++1.2.patched/include/arssym.h
--- arpack++1.2.orig/include/arssym.h	2000-02-21 13:05:00.000000000 +0100
+++ arpack++1.2.patched/include/arssym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARSSYM_H
 #define ARSSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arseig.h"
 #include "arrssym.h"
@@ -76,7 +77,7 @@ ARSymStdEig(int np, int nevp, ARFOP* obj
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, objOPp, MultOPxp, whichp,
                    ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -105,7 +106,7 @@ operator=(const ARSymStdEig<ARFLOAT, ARF
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arugcomp.h arpack++1.2.patched/include/arugcomp.h
--- arpack++1.2.orig/include/arugcomp.h	2000-02-21 18:46:32.000000000 +0100
+++ arpack++1.2.patched/include/arugcomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARUGCOMP_H
 #define ARUGCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arunsmat.h"
 #include "arunspen.h"
@@ -103,8 +104,8 @@ Copy(const ARluCompGenEig<ARFLOAT>& othe
   ARCompGenEig<ARFLOAT, ARumNonSymPencil<arcomplex<ARFLOAT>, ARFLOAT >,
                ARumNonSymPencil<arcomplex<ARFLOAT>, ARFLOAT> >:: Copy(other);
   Pencil = other.Pencil;
-  objOP  = &Pencil;
-  objB   = &Pencil;
+  this->objOP  = &Pencil;
+  this->objB   = &Pencil;
 
 } // Copy.
 
@@ -114,7 +115,7 @@ inline void ARluCompGenEig<ARFLOAT>::
 ChangeShift(arcomplex<ARFLOAT> sigmaRp)
 {
 
-  objOP->FactorAsB(sigmaRp);
+  this->objOP->FactorAsB(sigmaRp);
   ARrcStdEig<ARFLOAT, arcomplex<ARFLOAT> >::ChangeShift(sigmaRp);
 
 } // ChangeShift.
@@ -155,7 +156,7 @@ ARluCompGenEig(int nevp, ARumNonSymMatri
 {
 
   Pencil.DefineMatrices(A, B);
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &Pencil,
                    &ARumNonSymPencil<arcomplex<ARFLOAT>, ARFLOAT>::MultInvBAv,
                    &Pencil, 
@@ -192,7 +193,7 @@ operator=(const ARluCompGenEig<ARFLOAT>&
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arugnsym.h arpack++1.2.patched/include/arugnsym.h
--- arpack++1.2.orig/include/arugnsym.h	2000-02-21 18:42:32.000000000 +0100
+++ arpack++1.2.patched/include/arugnsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARUGNSYM_H
 #define ARUGNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arunsmat.h"
 #include "arunspen.h"
@@ -111,9 +112,9 @@ Copy(const ARluNonSymGenEig<ARFLOAT>& ot
   ARNonSymGenEig<ARFLOAT, ARumNonSymPencil<ARFLOAT, ARFLOAT>,
                  ARumNonSymPencil<ARFLOAT, ARFLOAT> >:: Copy(other);
   Pencil = other.Pencil;
-  objOP  = &Pencil;
-  objB   = &Pencil;
-  objA   = &Pencil;
+  this->objOP  = &Pencil;
+  this->objB   = &Pencil;
+  this->objA   = &Pencil;
 
 } // Copy.
 
@@ -124,10 +125,10 @@ ChangeShift(ARFLOAT sigmaRp, ARFLOAT sig
 {
 
   if (sigmaIp == 0.0) {
-    objOP->FactorAsB(sigmaRp);
+    this->objOP->FactorAsB(sigmaRp);
   }
   else {
-    objOP->FactorAsB(sigmaRp, sigmaIp, part);
+    this->objOP->FactorAsB(sigmaRp, sigmaIp, this->part);
   }
   ARrcNonSymGenEig<ARFLOAT>::ChangeShift(sigmaRp, sigmaIp);
 
@@ -179,7 +180,7 @@ ARluNonSymGenEig(int nevp, ARumNonSymMat
 {
 
   Pencil.DefineMatrices(A, B);
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &Pencil,
                    &ARumNonSymPencil<ARFLOAT, ARFLOAT>::MultInvBAv, &Pencil,
                    &ARumNonSymPencil<ARFLOAT, ARFLOAT>::MultBv, whichp,
@@ -233,7 +234,7 @@ operator=(const ARluNonSymGenEig<ARFLOAT
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arugsym.h arpack++1.2.patched/include/arugsym.h
--- arpack++1.2.orig/include/arugsym.h	2000-02-21 18:00:41.000000000 +0100
+++ arpack++1.2.patched/include/arugsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -19,7 +19,8 @@
 #ifndef ARUGSYM_H
 #define ARUGSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arusmat.h"
 #include "aruspen.h"
@@ -105,9 +106,9 @@ Copy(const ARluSymGenEig<ARFLOAT>& other
   ARSymGenEig<ARFLOAT, ARumSymPencil<ARFLOAT>,
               ARumSymPencil<ARFLOAT> >:: Copy(other);
   Pencil = other.Pencil;
-  objOP  = &Pencil;
-  objB   = &Pencil;
-  objA   = &Pencil;
+  this->objOP  = &Pencil;
+  this->objB   = &Pencil;
+  this->objA   = &Pencil;
 
 } // Copy.
 
@@ -116,7 +117,7 @@ template<class ARFLOAT>
 inline void ARluSymGenEig<ARFLOAT>::ChangeShift(ARFLOAT sigmap)
 {
 
-  objOP->FactorAsB(sigmap);
+  this->objOP->FactorAsB(sigmap);
   ARrcSymGenEig<ARFLOAT>::ChangeShift(sigmap);
 
 } // ChangeShift.
@@ -178,8 +179,8 @@ ARluSymGenEig(int nevp, ARumSymMatrix<AR
 {
 
   Pencil.DefineMatrices(A, B);
-  InvertMode = 'S';
-  NoShift();
+  this->InvertMode = 'S';
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &Pencil,
                    &ARumSymPencil<ARFLOAT>::MultInvBAv, &Pencil,
                    &ARumSymPencil<ARFLOAT>::MultBv, whichp,
@@ -202,8 +203,8 @@ ARluSymGenEig(char InvertModep, int nevp
                    &ARumSymPencil<ARFLOAT>::MultInvAsBv, &Pencil,
                    &ARumSymPencil<ARFLOAT>::MultBv, whichp,
                    ncvp, tolp, maxitp, residp, ishiftp);
-  InvertMode = CheckInvertMode(InvertModep);
-  switch (InvertMode) {
+  this->InvertMode = this->CheckInvertMode(InvertModep);
+  switch (this->InvertMode) {
   case 'B':  // Buckling mode.
     ChangeMultBx(&Pencil, &ARumSymPencil<ARFLOAT>::MultAv);
   case 'S':  // Shift and invert mode.
@@ -222,7 +223,7 @@ operator=(const ARluSymGenEig<ARFLOAT>& 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+   this->ClearMem();
     Copy(other);
   }
   return *this;
